/* Robot hand Prototype 1
 by D S-P <http://barraganstudio.com>
 This code is the basis for controlling two servos that will move the digits on a
 mechanical hand prototype.

 modified 8 Dec 2016
 by D S-P
 http://www.arduino.cc/en/Tutorial/Sweep
*/



#include <Servo.h> //Includes all commands and classes related to controlling servos.

Servo myservo1;  // create servo object to control a servo      
Servo myservo2;

const int b1 = 5; //Attaches button 1 to pin 5.
const int b2 = 3;

//Everything before the void setup is a global variable and some type of definition/inclusion.

void setup()// This contains all the necessary functions/variables that only need to be specified once.

{
  Serial.begin(9600); //Only necessary if using the serial monitor to track movement.
  myservo1.attach(9);  // attaches the servo on pin 9 to the servo object.
  myservo2.attach(11);
  pinMode(b1, INPUT_PULLUP); // labels b1 as an input and also activates internal resistor in the Arduino.
  pinMode(b2, INPUT_PULLUP);
}

bool b1trig = false, b1change = false; //b1trig if the yellow button is pressed. b1change if there is to be a change in position.
int b1pos = 0; //new position of the servo, initially at 0 degrees.
bool b2trig = false; //state of the red button.

bool b2change =  false; //b2trig if the red button is pressed. b2change if there is to be a change in position.
int b2pos = 0;



void loop() //Contains every function that needs to be specified repeatedly.
{ // BUTTON 2- Uses boolean logic to specify how each sero is meant to move and by how far. 
  //Represents the "closing" grip.

  for (int i =0; i < 100; i++){
    delay(15);
    if (digitalRead(b1) == LOW) //Specifies movement for servo 1. If the input of button one is low, then a response is warranted.
      b1trig = true; 
    if (b1trig)  { 
      if (b1change || b2trig)  { 
        b1pos++; 
        if (b1pos >= 0) { 
          b1trig = false; 
          b1change = false;
          b2trig = false;
        }
      }
      else  { 
        b1pos--;
        if (b1pos <= -90)  {
          b1change = true;
        }
      }
      myservo1.write(b1pos); //to write means to output the function. This is what makes the servo move to specified position.
      delay(500); 
  
      if (b1trig) { //begins specifying movement for servo 2.
        if (b1change || b2trig) { 
          if (b2pos <= 0) {
            b2trig = false; 
            b2change = false;
            b1trig = false;
          }
        }
        else {
          b2pos++;//
          if (b2pos >= 90) {
            b2change = true;
  
          }
        }
      }
      myservo2.write(b2pos);
      myservo1.detach();
      delay(300);
      myservo2.detach(); //Servos are detatched at the end of the function so that they cannot move and prevents the risk of overheating.
    }
  
    //BUTTON 2- Represents the hand coming back to the "resting" position.
  
    if (digitalRead(b2) == LOW) { //Specifies movement for Servo 2. If the input of button 2 is low, a response is warranted.
      myservo2.attach(11); //Triggers reattachment of the servos in order to complete the new function.
      myservo1.attach(9);
      int b1pos = 90; // the initial positions are now 90 degrees.
      int b2pos = 90;
      b1trig = true;
      if (b1trig) {
        if (b1change || b2trig) { 
          if (b2pos <= 90) {
            b2trig = false; 
            b2change = false;
            b1trig = false;
          }
        }
        else {
          b2pos--;//
          if (b2pos >= 0) {
            b2change = true;
            myservo2.write(b2pos); 
            delay(300);
           myservo2.detach();
          }
        }

  
  
        if (b1trig)  { // Specifies movement for servo 1.
          if (b1change || b2trig)  { 
            b1pos++; 
            if (b1pos <= 90) { 
              b1trig = false; 
              b1change = false;
              b2trig = false;
            }
          }
          else  { 
            b1pos--;
            if (b1pos >= 0)  {
              b1change = true;
  
            }
            myservo1.write(b1pos);
            delay(300);
            myservo1.detach();
          }
        }
      }
    }
   i++;
   Serial.println(i); //allows viewing of data in the serial monitor.
  }
}








